/* -*- Mode: C++; c-basic-offset:4 ; -*- */
/*  
 *  (C) 2001 by Argonne National Laboratory.
 *      See COPYRIGHT in top-level directory.
 *
 * This file is automatically generated by buildiface -nosep -noromio
 * DO NOT EDIT
 */
/* style: c++ header */

namespace MPI {
#ifdef HAVE_CXX_EXCEPTIONS
#define MPIX_CALL( fnc ) \
{int err; err = fnc ; if (err) throw Exception(err);}
#else
#define MPIX_CALL( fnc ) (void)fnc
#endif

// Typedefs for basic int types
typedef MPI_Offset Offset;
typedef MPI_Aint   Aint;
typedef MPI_Fint   Fint;
extern     void Finalize( void );
extern     bool Is_initialized( void );
extern     void Compute_dims( int v1, int v2, int * v3 );
extern     void Attach_buffer( void* v1, int v2 );
extern     void Get_processor_name( char * v1, int &v2 );
extern     void Get_error_string( int v1, char * v2, int * v3 );
extern     int Detach_buffer( void *&v1 );
extern     void Pcontrol( int v1, ... );
extern     int Get_error_class( int v1 );

class Datatype  {
    friend class Comm;
    friend class Status;
    friend class Intracomm;
    friend class Intercomm;
    friend class Win;
		
  protected:
    MPI_Datatype the_real_datatype;

  public:
    // new/delete
    inline Datatype(MPI_Datatype obj) { the_real_datatype = obj; }
    inline Datatype(void) {the_real_datatype = MPI_DATATYPE_NULL;}

    virtual ~Datatype() {}
    // copy/assignment
    Datatype(const Datatype &obj) {
      the_real_datatype = obj.the_real_datatype; }
    Datatype& operator=(const Datatype &obj) {
      the_real_datatype = obj.the_real_datatype; return *this; }

    // logical
    bool operator== (const Datatype &obj) {
      return (the_real_datatype == obj.the_real_datatype); }
    bool operator!= (const Datatype &obj) {
      return (the_real_datatype != obj.the_real_datatype); }
    // C/C++ cast and assignment
    inline operator MPI_Datatype*() { return &the_real_datatype; }
    inline operator MPI_Datatype() const { return the_real_datatype; }
    Datatype& operator=(const MPI_Datatype& obj) {
      the_real_datatype = obj; return *this; }
    void Free( void )
    {
        MPIX_CALL( MPI_Type_free( (MPI_Datatype *) &the_real_datatype ));
    }
    void Commit( void )
    {
        MPIX_CALL( MPI_Type_commit( (MPI_Datatype *) &the_real_datatype ));
    }
    Datatype Create_contiguous( int v1 )
    {
        Datatype *v3 = new Datatype;
        MPIX_CALL( MPI_Type_contiguous( v1, (MPI_Datatype) the_real_datatype, &(v3->the_real_datatype) ));
        return *v3;
    }
    Datatype Create_vector( int v1, int v2, int v3 )
    {
        Datatype *v5 = new Datatype;
        MPIX_CALL( MPI_Type_vector( v1, v2, v3, (MPI_Datatype) the_real_datatype, &(v5->the_real_datatype) ));
        return *v5;
    }
    Datatype Create_indexed( int v1, int * v2, int * v3 )
    {
        Datatype *v5 = new Datatype;
        MPIX_CALL( MPI_Type_indexed( v1, v2, v3, (MPI_Datatype) the_real_datatype, &(v5->the_real_datatype) ));
        return *v5;
    }
    int Pack_size( int v1, Comm v3 );
    static Datatype Create_struct( int v1, int v2[], MPI_Aint v3[], Datatype *v4 )
    {
        Datatype *v5 = new Datatype;
        MPI_Datatype *l4 = new MPI_Datatype[v1];
        { 
            int i4; 
            for (i4=0;i4<v1;i4++) {
                l4[i4] = v4[i4].the_real_datatype;
            }
        }
        MPIX_CALL( MPI_Type_create_struct( v1, v2, v3, l4, &(v5->the_real_datatype) ));
                    delete[] l4;
        return *v5;
    }
    int Get_size( void )
    {
        int v2;
        MPIX_CALL( MPI_Type_size( (MPI_Datatype) the_real_datatype, &v2 ));
        return v2;
    }
    void Get_name( char * v2, int * v3 )
    {
        MPIX_CALL( MPI_Type_get_name( (MPI_Datatype) the_real_datatype, v2, v3 ));
    }
    void Set_name( char * v2 )
    {
        MPIX_CALL( MPI_Type_set_name( (MPI_Datatype) the_real_datatype, v2 ));
    }

    void Unpack( const void *, int, void *, int, int &, const Comm & );
    void Pack( const void *, int, void *, int, int &, const Comm & );
};

typedef void User_function(const void *, void*, int, const Datatype&); 

class Info  {
    friend class File;
    friend class Win;
    friend class Comm;
		
  protected:
    MPI_Info the_real_info;

  public:
    // new/delete
    inline Info(MPI_Info obj) { the_real_info = obj; }
    inline Info(void) {the_real_info = MPI_INFO_NULL;}

    virtual ~Info() {}
    // copy/assignment
    Info(const Info &obj) {
      the_real_info = obj.the_real_info; }
    Info& operator=(const Info &obj) {
      the_real_info = obj.the_real_info; return *this; }

    // logical
    bool operator== (const Info &obj) {
      return (the_real_info == obj.the_real_info); }
    bool operator!= (const Info &obj) {
      return (the_real_info != obj.the_real_info); }
    // C/C++ cast and assignment
    inline operator MPI_Info*() { return &the_real_info; }
    inline operator MPI_Info() const { return the_real_info; }
    Info& operator=(const MPI_Info& obj) {
      the_real_info = obj; return *this; }
    int Get_nkeys( void )
    {
        int v2;
        MPIX_CALL( MPI_Info_get_nkeys( (MPI_Info) the_real_info, &v2 ));
        return v2;
    }
    void Set( const char * v2, const char * v3 )
    {
        MPIX_CALL( MPI_Info_set( (MPI_Info) the_real_info, (char *)v2, (char *)v3 ));
    }
    static Info Create( void )
    {
        Info *v1 = new Info;
        MPIX_CALL( MPI_Info_create( &(v1->the_real_info) ));
        return *v1;
    }
    bool Get_valuelen( const char * v2, int * v3 )
    {
        int v4;
        MPIX_CALL( MPI_Info_get_valuelen( (MPI_Info) the_real_info, (char *)v2, v3, &v4 ));
        return v4;
    }
    void Get_nthkey( int v2, char * v3 )
    {
        MPIX_CALL( MPI_Info_get_nthkey( (MPI_Info) the_real_info, v2, v3 ));
    }
    void Free( void )
    {
        MPIX_CALL( MPI_Info_free( (MPI_Info *) &the_real_info ));
    }
    bool Get( const char * v2, int v3, char * v4 )
    {
        int v5;
        MPIX_CALL( MPI_Info_get( (MPI_Info) the_real_info, (char *)v2, v3, v4, &v5 ));
        return v5;
    }
    void Delete( char * v2 )
    {
        MPIX_CALL( MPI_Info_delete( (MPI_Info) the_real_info, v2 ));
    }
    Info Dup( void )
    {
        Info *v2 = new Info;
        MPIX_CALL( MPI_Info_dup( (MPI_Info) the_real_info, &(v2->the_real_info) ));
        return *v2;
    }
};

class Status  {
    friend class Comm;
    friend class File;
    friend class Request;
		
  protected:
    MPI_Status the_real_status;

  public:
    // new/delete
    inline Status(MPI_Status obj) { the_real_status = obj; }
    inline Status(void) {}

    virtual ~Status() {}
    // copy/assignment
    Status(const Status &obj) {
      the_real_status = obj.the_real_status; }
    Status& operator=(const Status &obj) {
      the_real_status = obj.the_real_status; return *this; }

    // C/C++ cast and assignment
    inline operator MPI_Status*() { return &the_real_status; }
    inline operator MPI_Status() const { return the_real_status; }
    Status& operator=(const MPI_Status& obj) {
      the_real_status = obj; return *this; }
    bool Is_cancelled( void )
    {
        int v2;
        MPIX_CALL( MPI_Test_cancelled( (MPI_Status *) &the_real_status, &v2 ));
        return v2;
    }
    int Get_elements( Datatype v2 )
    {
        int v3;
        MPIX_CALL( MPI_Get_elements( (MPI_Status *) &the_real_status, (MPI_Datatype)(v2.the_real_datatype), &v3 ));
        return v3;
    }
    int Get_count( Datatype v2 )
    {
        int v3;
        MPIX_CALL( MPI_Get_count( (MPI_Status *) &the_real_status, (MPI_Datatype)(v2.the_real_datatype), &v3 ));
        return v3;
    }

    int Get_source(void) { return the_real_status.MPI_SOURCE; }
    int Get_tag(void) { return the_real_status.MPI_TAG; }
    int Get_error(void) { return the_real_status.MPI_ERROR; }
    void Set_source(int source) { the_real_status.MPI_SOURCE = source; }
    void Set_tag(int tag) { the_real_status.MPI_TAG = tag; }
    void Set_error(int error) { the_real_status.MPI_ERROR = error; }
};

class Group  {
    friend class Comm;
    friend class Intracomm;
    friend class Intercomm;
    friend class Win;
    friend class File;
		
  protected:
    MPI_Group the_real_group;

  public:
    // new/delete
    inline Group(MPI_Group obj) { the_real_group = obj; }
    inline Group(void) {the_real_group = MPI_GROUP_NULL;}

    virtual ~Group() {}
    // copy/assignment
    Group(const Group &obj) {
      the_real_group = obj.the_real_group; }
    Group& operator=(const Group &obj) {
      the_real_group = obj.the_real_group; return *this; }

    // logical
    bool operator== (const Group &obj) {
      return (the_real_group == obj.the_real_group); }
    bool operator!= (const Group &obj) {
      return (the_real_group != obj.the_real_group); }
    // C/C++ cast and assignment
    inline operator MPI_Group*() { return &the_real_group; }
    inline operator MPI_Group() const { return the_real_group; }
    Group& operator=(const MPI_Group& obj) {
      the_real_group = obj; return *this; }
    static int Compare( Group v1, Group v2 )
    {
        int v3;
        MPIX_CALL( MPI_Group_compare( (MPI_Group)(v1.the_real_group), (MPI_Group)(v2.the_real_group), &v3 ));
        return v3;
    }
    static Group Difference( Group v1, Group v2 )
    {
        Group *v3 = new Group;
        MPIX_CALL( MPI_Group_difference( (MPI_Group)(v1.the_real_group), (MPI_Group)(v2.the_real_group), &(v3->the_real_group) ));
        return *v3;
    }
    Group Range_excl( int v2, int v3[][3] )
    {
        Group *v4 = new Group;
        MPIX_CALL( MPI_Group_range_excl( (MPI_Group) the_real_group, v2, v3, &(v4->the_real_group) ));
        return *v4;
    }
    Group Range_incl( int v2, int v3[][3] )
    {
        Group *v4 = new Group;
        MPIX_CALL( MPI_Group_range_incl( (MPI_Group) the_real_group, v2, v3, &(v4->the_real_group) ));
        return *v4;
    }
    static Group Intersect( Group v1, Group v2 )
    {
        Group *v3 = new Group;
        MPIX_CALL( MPI_Group_intersection( (MPI_Group)(v1.the_real_group), (MPI_Group)(v2.the_real_group), &(v3->the_real_group) ));
        return *v3;
    }
    int Get_size( void )
    {
        int v2;
        MPIX_CALL( MPI_Group_size( (MPI_Group) the_real_group, &v2 ));
        return v2;
    }
    static Group Union( Group v1, Group v2 )
    {
        Group *v3 = new Group;
        MPIX_CALL( MPI_Group_union( (MPI_Group)(v1.the_real_group), (MPI_Group)(v2.the_real_group), &(v3->the_real_group) ));
        return *v3;
    }
    void Free( void )
    {
        MPIX_CALL( MPI_Group_free( (MPI_Group *) &the_real_group ));
    }
    int Get_rank( void )
    {
        int v2;
        MPIX_CALL( MPI_Group_rank( (MPI_Group) the_real_group, &v2 ));
        return v2;
    }
    Group Excl( int v2, int * v3 )
    {
        Group *v4 = new Group;
        MPIX_CALL( MPI_Group_excl( (MPI_Group) the_real_group, v2, v3, &(v4->the_real_group) ));
        return *v4;
    }
    Group Incl( int v2, int * v3 )
    {
        Group *v4 = new Group;
        MPIX_CALL( MPI_Group_incl( (MPI_Group) the_real_group, v2, v3, &(v4->the_real_group) ));
        return *v4;
    }
    static void Translate_ranks( Group v1, int v2, int * v3, Group v4, int * v5 )
    {
        MPIX_CALL( MPI_Group_translate_ranks( (MPI_Group)(v1.the_real_group), v2, v3, (MPI_Group)(v4.the_real_group), v5 ));
    }
};

class Op  {
    friend class Intracomm;
    friend class Intercomm;
    friend class Win;
		
  protected:
    MPI_Op the_real_op;

  public:
    // new/delete
    inline Op(MPI_Op obj) { the_real_op = obj; }
    inline Op(void) {the_real_op = MPI_OP_NULL;}

    virtual ~Op() {}
    // copy/assignment
    Op(const Op &obj) {
      the_real_op = obj.the_real_op; }
    Op& operator=(const Op &obj) {
      the_real_op = obj.the_real_op; return *this; }

    // logical
    bool operator== (const Op &obj) {
      return (the_real_op == obj.the_real_op); }
    bool operator!= (const Op &obj) {
      return (the_real_op != obj.the_real_op); }
    // C/C++ cast and assignment
    inline operator MPI_Op*() { return &the_real_op; }
    inline operator MPI_Op() const { return the_real_op; }
    Op& operator=(const MPI_Op& obj) {
      the_real_op = obj; return *this; }
    void Free( void )
    {
        MPIX_CALL( MPI_Op_free( (MPI_Op *) &the_real_op ));
    }

    void Init( User_function *, bool );
};

class Errhandler  {
    friend class Comm;
		
  protected:
    MPI_Errhandler the_real_errhandler;

  public:
    // new/delete
    inline Errhandler(MPI_Errhandler obj) { the_real_errhandler = obj; }
    inline Errhandler(void) {the_real_errhandler = MPI_ERRHANDLER_NULL;}

    virtual ~Errhandler() {}
    // copy/assignment
    Errhandler(const Errhandler &obj) {
      the_real_errhandler = obj.the_real_errhandler; }
    Errhandler& operator=(const Errhandler &obj) {
      the_real_errhandler = obj.the_real_errhandler; return *this; }

    // logical
    bool operator== (const Errhandler &obj) {
      return (the_real_errhandler == obj.the_real_errhandler); }
    bool operator!= (const Errhandler &obj) {
      return (the_real_errhandler != obj.the_real_errhandler); }
    // C/C++ cast and assignment
    inline operator MPI_Errhandler*() { return &the_real_errhandler; }
    inline operator MPI_Errhandler() const { return the_real_errhandler; }
    Errhandler& operator=(const MPI_Errhandler& obj) {
      the_real_errhandler = obj; return *this; }
    void Free( void )
    {
        MPIX_CALL( MPI_Errhandler_free( (MPI_Errhandler *) &the_real_errhandler ));
    }
};

class Exception  {
		
  protected:
    int the_real_exception;

  public:
    // new/delete
    inline Exception(int obj) { the_real_exception = obj; }
    inline Exception(void) {the_real_exception = 0;}

    virtual ~Exception() {}
    // copy/assignment
    Exception(const Exception &obj) {
      the_real_exception = obj.the_real_exception; }
    Exception& operator=(const Exception &obj) {
      the_real_exception = obj.the_real_exception; return *this; }

    // logical
    bool operator== (const Exception &obj) {
      return (the_real_exception == obj.the_real_exception); }
    bool operator!= (const Exception &obj) {
      return (the_real_exception != obj.the_real_exception); }
    // C/C++ cast and assignment
    inline operator int*() { return &the_real_exception; }
    inline operator int() const { return the_real_exception; }
    Exception& operator=(const int& obj) {
      the_real_exception = obj; return *this; }

    int Get_error_code(void) { return the_real_exception; } 
    int Get_error_class(void) { return MPI::Get_error_class(the_real_exception); } 
    const char *Get_error_string(void) { return 0;}
};

class Request  {
    friend class Comm;
		
  protected:
    MPI_Request the_real_request;

  public:
    // new/delete
    inline Request(MPI_Request obj) { the_real_request = obj; }
    inline Request(void) {the_real_request = MPI_REQUEST_NULL;}

    virtual ~Request() {}
    // copy/assignment
    Request(const Request &obj) {
      the_real_request = obj.the_real_request; }
    Request& operator=(const Request &obj) {
      the_real_request = obj.the_real_request; return *this; }

    // logical
    bool operator== (const Request &obj) {
      return (the_real_request == obj.the_real_request); }
    bool operator!= (const Request &obj) {
      return (the_real_request != obj.the_real_request); }
    // C/C++ cast and assignment
    inline operator MPI_Request*() { return &the_real_request; }
    inline operator MPI_Request() const { return the_real_request; }
    Request& operator=(const MPI_Request& obj) {
      the_real_request = obj; return *this; }
    static bool Testany( int v1, Request v2[], int &v3, Status & v5 )
    {
        int v4;
        MPI_Request *l2 = new MPI_Request[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Testany( v1, l2, &v3, &v4, (MPI_Status *)&(v5.the_real_status ) ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
        return v4;
    }
    static bool Testany( int v1, Request v2[], int &v3 )
    {
        int v4;
        MPI_Request *l2 = new MPI_Request[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Testany( v1, l2, &v3, &v4, MPI_STATUS_IGNORE ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
        return v4;
    }
    void Cancel( void )
    {
        MPIX_CALL( MPI_Cancel( (MPI_Request *) &the_real_request ));
    }
    static void Waitall( int v1, Request v2[], Status v3[] )
    {
        MPI_Request *l2 = new MPI_Request[v1];
        MPI_Status *l3 = new MPI_Status[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Waitall( v1, l2, l3 ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
        { 
            int i3; 
            for (i3=0;i3<v1;i3++) {
                v3[i3].the_real_status = l3[i3];
            }
            delete[] l3;
        }
    }
    static void Waitall( int v1, Request v2[] )
    {
        MPI_Request *l2 = new MPI_Request[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Waitall( v1, l2, MPI_STATUSES_IGNORE ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
    }
    void Free( void )
    {
        MPIX_CALL( MPI_Request_free( (MPI_Request *) &the_real_request ));
    }
    void Wait( Status & v2 )
    {
        MPIX_CALL( MPI_Wait( (MPI_Request *) &the_real_request, (MPI_Status *)&(v2.the_real_status ) ));
    }
    void Wait( void )
    {
        MPIX_CALL( MPI_Wait( (MPI_Request *) &the_real_request, MPI_STATUS_IGNORE ));
    }
    static int Waitany( int v1, Request v2[], Status & v4 )
    {
        int v3;
        MPI_Request *l2 = new MPI_Request[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Waitany( v1, l2, &v3, (MPI_Status *)&(v4.the_real_status ) ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
        return v3;
    }
    static int Waitany( int v1, Request v2[] )
    {
        int v3;
        MPI_Request *l2 = new MPI_Request[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Waitany( v1, l2, &v3, MPI_STATUS_IGNORE ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
        return v3;
    }
    static int Testsome( int v1, Request v2[], int * v4, Status v5[] )
    {
        int v3;
        MPI_Request *l2 = new MPI_Request[v1];
        MPI_Status *l5 = new MPI_Status[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Testsome( v1, l2, &v3, v4, l5 ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
        { 
            int i5; 
            for (i5=0;i5<v1;i5++) {
                v5[i5].the_real_status = l5[i5];
            }
            delete[] l5;
        }
        return v3;
    }
    static int Testsome( int v1, Request v2[], int * v4 )
    {
        int v3;
        MPI_Request *l2 = new MPI_Request[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Testsome( v1, l2, &v3, v4, MPI_STATUSES_IGNORE ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
        return v3;
    }
    static int Waitsome( int v1, Request v2[], int * v4, Status v5[] )
    {
        int v3;
        MPI_Request *l2 = new MPI_Request[v1];
        MPI_Status *l5 = new MPI_Status[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Waitsome( v1, l2, &v3, v4, l5 ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
        { 
            int i5; 
            for (i5=0;i5<v1;i5++) {
                v5[i5].the_real_status = l5[i5];
            }
            delete[] l5;
        }
        return v3;
    }
    static int Waitsome( int v1, Request v2[], int * v4 )
    {
        int v3;
        MPI_Request *l2 = new MPI_Request[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Waitsome( v1, l2, &v3, v4, MPI_STATUSES_IGNORE ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
        return v3;
    }
    static bool Testall( int v1, Request v2[], Status v4[] )
    {
        int v3;
        MPI_Request *l2 = new MPI_Request[v1];
        MPI_Status *l4 = new MPI_Status[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Testall( v1, l2, &v3, l4 ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
        { 
            int i4; 
            for (i4=0;i4<v1;i4++) {
                v4[i4].the_real_status = l4[i4];
            }
            delete[] l4;
        }
        return v3;
    }
    static bool Testall( int v1, Request v2[] )
    {
        int v3;
        MPI_Request *l2 = new MPI_Request[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Testall( v1, l2, &v3, MPI_STATUSES_IGNORE ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
        return v3;
    }
    bool Test( Status & v3 )
    {
        int v2;
        MPIX_CALL( MPI_Test( (MPI_Request *) &the_real_request, &v2, (MPI_Status *)&(v3.the_real_status ) ));
        return v2;
    }
    bool Test( void )
    {
        int v2;
        MPIX_CALL( MPI_Test( (MPI_Request *) &the_real_request, &v2, MPI_STATUS_IGNORE ));
        return v2;
    }
};

class Prequest : public Request {

  public:
    // new/delete
    inline Prequest(MPI_Request obj) { the_real_request = obj; }
    inline Prequest(void) {the_real_request = MPI_REQUEST_NULL;}

    virtual ~Prequest() {}
    // copy/assignment
    Prequest(const Prequest &obj) {
      the_real_request = obj.the_real_request; }
    Prequest& operator=(const Prequest &obj) {
      the_real_request = obj.the_real_request; return *this; }

    // logical
    bool operator== (const Prequest &obj) {
      return (the_real_request == obj.the_real_request); }
    bool operator!= (const Prequest &obj) {
      return (the_real_request != obj.the_real_request); }
    // C/C++ cast and assignment
    inline operator MPI_Request*() { return &the_real_request; }
    inline operator MPI_Request() const { return the_real_request; }
    Prequest& operator=(const MPI_Request& obj) {
      the_real_request = obj; return *this; }
    void Start( void )
    {
        MPIX_CALL( MPI_Start( (MPI_Request *) &the_real_request ));
    }
    static void Startall( int v1, Prequest v2[] )
    {
        MPI_Request *l2 = new MPI_Request[v1];
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                l2[i2] = v2[i2].the_real_request;
            }
        }
        MPIX_CALL( MPI_Startall( v1, l2 ));
        { 
            int i2; 
            for (i2=0;i2<v1;i2++) {
                v2[i2].the_real_request = l2[i2];
            }
            delete[] l2;
        }
    }
};

class Comm  {
    friend class Cartcomm;
    friend class Intercomm;
    friend class Intracomm;
    friend class Graphcomm;
    friend class Datatype;
    friend class Win;
    friend class File;
		
  protected:
    MPI_Comm the_real_comm;

  public:
    // new/delete
    inline Comm(MPI_Comm obj) { the_real_comm = obj; }
    inline Comm(void) {the_real_comm = MPI_COMM_NULL;}

    virtual ~Comm() {}
    // copy/assignment
    Comm(const Comm &obj) {
      the_real_comm = obj.the_real_comm; }
    Comm& operator=(const Comm &obj) {
      the_real_comm = obj.the_real_comm; return *this; }

    // logical
    bool operator== (const Comm &obj) {
      return (the_real_comm == obj.the_real_comm); }
    bool operator!= (const Comm &obj) {
      return (the_real_comm != obj.the_real_comm); }
    // C/C++ cast and assignment
    inline operator MPI_Comm*() { return &the_real_comm; }
    inline operator MPI_Comm() const { return the_real_comm; }
    Comm& operator=(const MPI_Comm& obj) {
      the_real_comm = obj; return *this; }
    void Abort( int v2 )
    {
        MPIX_CALL( MPI_Abort( (MPI_Comm) the_real_comm, v2 ));
    }
    Request Issend( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Issend( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    void Rsend( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        MPIX_CALL( MPI_Rsend( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm ));
    }
    int Get_size( void )
    {
        int v2;
        MPIX_CALL( MPI_Comm_size( (MPI_Comm) the_real_comm, &v2 ));
        return v2;
    }
    void Send( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        MPIX_CALL( MPI_Send( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm ));
    }
    int Get_topology( void )
    {
        int v2;
        MPIX_CALL( MPI_Topo_test( (MPI_Comm) the_real_comm, &v2 ));
        return v2;
    }
    void Free( void )
    {
        MPIX_CALL( MPI_Comm_free( (MPI_Comm *) &the_real_comm ));
    }
    void Ssend( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        MPIX_CALL( MPI_Ssend( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm ));
    }
    Errhandler Get_errhandler( void )
    {
        Errhandler *v2 = new Errhandler;
        MPIX_CALL( MPI_Comm_get_errhandler( (MPI_Comm) the_real_comm, &(v2->the_real_errhandler) ));
        return *v2;
    }
    Request Ibsend( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Ibsend( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    void Sendrecv( void * v1, int v2, Datatype v3, int v4, int v5, void * v6, int v7, Datatype v8, int v9, int v10, Status & v12 )
    {
        MPIX_CALL( MPI_Sendrecv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, v7, (MPI_Datatype)(v8.the_real_datatype), v9, v10, (MPI_Comm) the_real_comm, (MPI_Status *)&(v12.the_real_status ) ));
    }
    void Sendrecv( void * v1, int v2, Datatype v3, int v4, int v5, void * v6, int v7, Datatype v8, int v9, int v10 )
    {
        MPIX_CALL( MPI_Sendrecv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, v7, (MPI_Datatype)(v8.the_real_datatype), v9, v10, (MPI_Comm) the_real_comm, MPI_STATUS_IGNORE ));
    }
    Request Recv_init( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Recv_init( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    Request Bsend_init( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Bsend_init( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    Request Irecv( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Irecv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    Request Rsend_init( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Rsend_init( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    static int Compare( Comm v1, Comm v2 )
    {
        int v3;
        MPIX_CALL( MPI_Comm_compare( (MPI_Comm)(v1.the_real_comm), (MPI_Comm)(v2.the_real_comm), &v3 ));
        return v3;
    }
    void Bsend( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        MPIX_CALL( MPI_Bsend( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm ));
    }
    void Set_errhandler( Errhandler v2 )
    {
        MPIX_CALL( MPI_Comm_set_errhandler( (MPI_Comm) the_real_comm, (MPI_Errhandler)(v2.the_real_errhandler) ));
    }
    Request Isend( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Isend( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    bool Iprobe( int v1, int v2, Status & v5 )
    {
        int v4;
        MPIX_CALL( MPI_Iprobe( v1, v2, (MPI_Comm) the_real_comm, &v4, (MPI_Status *)&(v5.the_real_status ) ));
        return v4;
    }
    bool Iprobe( int v1, int v2 )
    {
        int v4;
        MPIX_CALL( MPI_Iprobe( v1, v2, (MPI_Comm) the_real_comm, &v4, MPI_STATUS_IGNORE ));
        return v4;
    }
    Request Send_init( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Send_init( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    int Get_rank( void )
    {
        int v2;
        MPIX_CALL( MPI_Comm_rank( (MPI_Comm) the_real_comm, &v2 ));
        return v2;
    }
    Request Ssend_init( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Ssend_init( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    void Sendrecv_replace( void* v1, int v2, Datatype v3, int v4, int v5, int v6, int v7, Status & v9 )
    {
        MPIX_CALL( MPI_Sendrecv_replace( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, v7, (MPI_Comm) the_real_comm, (MPI_Status *)&(v9.the_real_status ) ));
    }
    void Sendrecv_replace( void* v1, int v2, Datatype v3, int v4, int v5, int v6, int v7 )
    {
        MPIX_CALL( MPI_Sendrecv_replace( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, v7, (MPI_Comm) the_real_comm, MPI_STATUS_IGNORE ));
    }
    Group Get_group( void )
    {
        Group *v2 = new Group;
        MPIX_CALL( MPI_Comm_group( (MPI_Comm) the_real_comm, &(v2->the_real_group) ));
        return *v2;
    }
    bool Is_inter( void )
    {
        int v2;
        MPIX_CALL( MPI_Comm_test_inter( (MPI_Comm) the_real_comm, &v2 ));
        return v2;
    }
    void Probe( int v1, int v2, Status & v4 )
    {
        MPIX_CALL( MPI_Probe( v1, v2, (MPI_Comm) the_real_comm, (MPI_Status *)&(v4.the_real_status ) ));
    }
    void Probe( int v1, int v2 )
    {
        MPIX_CALL( MPI_Probe( v1, v2, (MPI_Comm) the_real_comm, MPI_STATUS_IGNORE ));
    }
    Request Irsend( const void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Irsend( (void*)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    void Recv( void* v1, int v2, Datatype v3, int v4, int v5, Status & v7 )
    {
        MPIX_CALL( MPI_Recv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, (MPI_Status *)&(v7.the_real_status ) ));
    }
    void Recv( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        MPIX_CALL( MPI_Recv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, MPI_STATUS_IGNORE ));
    }
    int Get_attr( int v2, void * v3 )
    {
        int v4;
        MPIX_CALL( MPI_Comm_get_attr( (MPI_Comm) the_real_comm, v2, v3, &v4 ));
        return v4;
    }
    void Set_attr( int v2, void * v3 )
    {
        MPIX_CALL( MPI_Comm_set_attr( (MPI_Comm) the_real_comm, v2, v3 ));
    }
    void Delete_attr( int v2 )
    {
        MPIX_CALL( MPI_Comm_delete_attr( (MPI_Comm) the_real_comm, v2 ));
    }
    static void Free_keyval( int &v1 )
    {
        MPIX_CALL( MPI_Comm_free_keyval( &v1 ));
    }
    Comm & Clone(void) const { 
        MPI_Comm ncomm;
        MPI_Comm_dup( (MPI_Comm)the_real_comm, &ncomm); 
        Comm *clone = new Comm(ncomm); 
        return *clone; };

typedef int Copy_attr_function(const Comm& oldcomm, int comm_keyval, void* extra_state, void* attribute_val_in, void* attribute_val_out, bool& flag); 
typedef int Delete_attr_function(Comm& comm, int comm_keyval, void* attribute_val, void* extra_state); 
typedef void Errhandler_fn(Comm &, int *, ... );

    static int Create_keyval( Copy_attr_function *, Delete_attr_function *,
                              void * );
          
    static int NULL_COPY_FN( const Comm &oldcomm, int keyval, void *ex,
    void *attr_in, void *attr_out, bool &flag ) { flag = 1; return 0;}
    static int NULL_DELETE_FN( Comm &comm, int keyval, void * attr, void *ex )
	{ return 0; }
    static int DUP_FN( const Comm &oldcomm, int keyval, void *ex,
    void *attr_in, void *attr_out, bool &flag ) { flag = 1; 
    *(void **)attr_out = attr_in; return 0;} 
};

class Intercomm : public Comm {
    friend class Intracomm;

  public:
    // new/delete
    inline Intercomm(MPI_Comm obj) { the_real_comm = obj; }
    inline Intercomm(void) {the_real_comm = MPI_COMM_NULL;}

    virtual ~Intercomm() {}
    // copy/assignment
    Intercomm(const Intercomm &obj) {
      the_real_comm = obj.the_real_comm; }
    Intercomm& operator=(const Intercomm &obj) {
      the_real_comm = obj.the_real_comm; return *this; }

    // C/C++ cast and assignment
    inline operator MPI_Comm*() { return &the_real_comm; }
    inline operator MPI_Comm() const { return the_real_comm; }
    Intercomm& operator=(const MPI_Comm& obj) {
      the_real_comm = obj; return *this; }
    Group Get_remote_group( void )
    {
        Group *v2 = new Group;
        MPIX_CALL( MPI_Comm_remote_group( (MPI_Comm) the_real_comm, &(v2->the_real_group) ));
        return *v2;
    }
    int Get_remote_size( void )
    {
        int v2;
        MPIX_CALL( MPI_Comm_remote_size( (MPI_Comm) the_real_comm, &v2 ));
        return v2;
    }
    Comm Merge( bool v2 )
    {
        Comm *v3 = new Comm;
        int l2;
         l2 = (v2 == true) ? 1 : 0;
        MPIX_CALL( MPI_Intercomm_merge( (MPI_Comm) the_real_comm, l2, &(v3->the_real_comm) ));
        return *v3;
    }
    Comm Dup( void )
    {
        Comm *v2 = new Comm;
        MPIX_CALL( MPI_Comm_dup( (MPI_Comm) the_real_comm, &(v2->the_real_comm) ));
        return *v2;
    }
    void Scan( void* v1, void* v2, int v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Scan( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
    void Reduce( void* v1, void* v2, int v3, Datatype v4, Op v5, int v6 )
    {
        MPIX_CALL( MPI_Reduce( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), v6, (MPI_Comm) the_real_comm ));
    }
    void Bcast( void* v1, int v2, Datatype v3, int v4 )
    {
        MPIX_CALL( MPI_Bcast( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, (MPI_Comm) the_real_comm ));
    }
    void Alltoallv( void* v1, int * v2, int * v3, Datatype v4, void* v5, int * v6, int * v7, Datatype v8 )
    {
        MPIX_CALL( MPI_Alltoallv( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), v5, v6, v7, (MPI_Datatype)(v8.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    void Barrier( void )
    {
        MPIX_CALL( MPI_Barrier( (MPI_Comm) the_real_comm ));
    }
    void Alltoall( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6 )
    {
        MPIX_CALL( MPI_Alltoall( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    void Gather( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6, int v7 )
    {
        MPIX_CALL( MPI_Gather( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), v7, (MPI_Comm) the_real_comm ));
    }
    void Reduce_scatter( void* v1, void* v2, int * v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Reduce_scatter( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
    void Allreduce( void* v1, void* v2, int v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Allreduce( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
    void Gatherv( void* v1, int v2, Datatype v3, void* v4, int * v5, int * v6, Datatype v7, int v8 )
    {
        MPIX_CALL( MPI_Gatherv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, (MPI_Datatype)(v7.the_real_datatype), v8, (MPI_Comm) the_real_comm ));
    }
    void Scatter( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6, int v7 )
    {
        MPIX_CALL( MPI_Scatter( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), v7, (MPI_Comm) the_real_comm ));
    }
    void Scatterv( void* v1, int * v2, int * v3, Datatype v4, void* v5, int v6, Datatype v7, int v8 )
    {
        MPIX_CALL( MPI_Scatterv( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), v5, v6, (MPI_Datatype)(v7.the_real_datatype), v8, (MPI_Comm) the_real_comm ));
    }
    void Allgatherv( void* v1, int v2, Datatype v3, void* v4, int * v5, int * v6, Datatype v7 )
    {
        MPIX_CALL( MPI_Allgatherv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, (MPI_Datatype)(v7.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    void Allgather( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6 )
    {
        MPIX_CALL( MPI_Allgather( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    void Exscan( void * v1, void * v2, int v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Exscan( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
};

class Intracomm : public Comm {
    friend class Cartcomm;
    friend class Graphcomm;
    friend class Datatype;

  public:
    // new/delete
    inline Intracomm(MPI_Comm obj) { the_real_comm = obj; }
    inline Intracomm(void) {the_real_comm = MPI_COMM_NULL;}

    virtual ~Intracomm() {}
    // copy/assignment
    Intracomm(const Intracomm &obj) {
      the_real_comm = obj.the_real_comm; }
    Intracomm& operator=(const Intracomm &obj) {
      the_real_comm = obj.the_real_comm; return *this; }

    // C/C++ cast and assignment
    inline operator MPI_Comm*() { return &the_real_comm; }
    inline operator MPI_Comm() const { return the_real_comm; }
    Intracomm& operator=(const MPI_Comm& obj) {
      the_real_comm = obj; return *this; }
    Comm Create( Group v2 )
    {
        Comm *v3 = new Comm;
        MPIX_CALL( MPI_Comm_create( (MPI_Comm) the_real_comm, (MPI_Group)(v2.the_real_group), &(v3->the_real_comm) ));
        return *v3;
    }
    void Bcast( void* v1, int v2, Datatype v3, int v4 )
    {
        MPIX_CALL( MPI_Bcast( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, (MPI_Comm) the_real_comm ));
    }
    void Barrier( void )
    {
        MPIX_CALL( MPI_Barrier( (MPI_Comm) the_real_comm ));
    }
    void Alltoall( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6 )
    {
        MPIX_CALL( MPI_Alltoall( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    void Gather( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6, int v7 )
    {
        MPIX_CALL( MPI_Gather( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), v7, (MPI_Comm) the_real_comm ));
    }
    Comm Create_intercomm( int v2, Comm v3, int v4, int v5 )
    {
        Comm *v6 = new Comm;
        MPIX_CALL( MPI_Intercomm_create( (MPI_Comm) the_real_comm, v2, (MPI_Comm)(v3.the_real_comm), v4, v5, &(v6->the_real_comm) ));
        return *v6;
    }
    void Reduce_scatter( void* v1, void* v2, int * v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Reduce_scatter( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
    void Scatterv( void* v1, int * v2, int * v3, Datatype v4, void* v5, int v6, Datatype v7, int v8 )
    {
        MPIX_CALL( MPI_Scatterv( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), v5, v6, (MPI_Datatype)(v7.the_real_datatype), v8, (MPI_Comm) the_real_comm ));
    }
    void Allgather( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6 )
    {
        MPIX_CALL( MPI_Allgather( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    Comm Dup( void )
    {
        Comm *v2 = new Comm;
        MPIX_CALL( MPI_Comm_dup( (MPI_Comm) the_real_comm, &(v2->the_real_comm) ));
        return *v2;
    }
    void Reduce( void* v1, void* v2, int v3, Datatype v4, Op v5, int v6 )
    {
        MPIX_CALL( MPI_Reduce( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), v6, (MPI_Comm) the_real_comm ));
    }
    void Scan( void* v1, void* v2, int v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Scan( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
    void Alltoallv( void* v1, int * v2, int * v3, Datatype v4, void* v5, int * v6, int * v7, Datatype v8 )
    {
        MPIX_CALL( MPI_Alltoallv( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), v5, v6, v7, (MPI_Datatype)(v8.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    Comm Create_cart( int v2, int * v3, bool v4[], bool v5 )
    {
        Comm *v6 = new Comm;
        int *l4 = new int[v2];
        int l5;
        { 
            int i4; 
            for (i4=0;i4<v2;i4++) {
                l4[i4] = v4[i4] == true ? 1 : 0;
            }
        }
         l5 = (v5 == true) ? 1 : 0;
        MPIX_CALL( MPI_Cart_create( (MPI_Comm) the_real_comm, v2, v3, l4, l5, &(v6->the_real_comm) ));

            delete[] l4;
        return *v6;
    }
    void Allreduce( void* v1, void* v2, int v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Allreduce( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
    Comm Split( int v2, int v3 )
    {
        Comm *v4 = new Comm;
        MPIX_CALL( MPI_Comm_split( (MPI_Comm) the_real_comm, v2, v3, &(v4->the_real_comm) ));
        return *v4;
    }
    void Allgatherv( void* v1, int v2, Datatype v3, void* v4, int * v5, int * v6, Datatype v7 )
    {
        MPIX_CALL( MPI_Allgatherv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, (MPI_Datatype)(v7.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    void Scatter( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6, int v7 )
    {
        MPIX_CALL( MPI_Scatter( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), v7, (MPI_Comm) the_real_comm ));
    }
    void Gatherv( void* v1, int v2, Datatype v3, void* v4, int * v5, int * v6, Datatype v7, int v8 )
    {
        MPIX_CALL( MPI_Gatherv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, (MPI_Datatype)(v7.the_real_datatype), v8, (MPI_Comm) the_real_comm ));
    }
    Comm Create_graph( int v2, int * v3, int * v4, bool v5 )
    {
        Comm *v6 = new Comm;
        int l5;
         l5 = (v5 == true) ? 1 : 0;
        MPIX_CALL( MPI_Graph_create( (MPI_Comm) the_real_comm, v2, v3, v4, l5, &(v6->the_real_comm) ));
        return *v6;
    }
    void Exscan( void * v1, void * v2, int v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Exscan( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
};

class Grequest : public Request {

  public:
    // new/delete
    inline Grequest(MPI_Request obj) { the_real_request = obj; }
    inline Grequest(void) {the_real_request = MPI_REQUEST_NULL;}

    virtual ~Grequest() {}
    // copy/assignment
    Grequest(const Grequest &obj) {
      the_real_request = obj.the_real_request; }
    Grequest& operator=(const Grequest &obj) {
      the_real_request = obj.the_real_request; return *this; }

    // logical
    bool operator== (const Grequest &obj) {
      return (the_real_request == obj.the_real_request); }
    bool operator!= (const Grequest &obj) {
      return (the_real_request != obj.the_real_request); }
    // C/C++ cast and assignment
    inline operator MPI_Request*() { return &the_real_request; }
    inline operator MPI_Request() const { return the_real_request; }
    Grequest& operator=(const MPI_Request& obj) {
      the_real_request = obj; return *this; }
    void Complete( void )
    {
        MPIX_CALL( MPI_Grequest_complete( (MPI_Request) the_real_request ));
    }
};

class Win  {
		
  protected:
    MPI_Win the_real_win;

  public:
    // new/delete
    inline Win(MPI_Win obj) { the_real_win = obj; }
    inline Win(void) {the_real_win = MPI_WIN_NULL;}

    virtual ~Win() {}
    // copy/assignment
    Win(const Win &obj) {
      the_real_win = obj.the_real_win; }
    Win& operator=(const Win &obj) {
      the_real_win = obj.the_real_win; return *this; }

    // logical
    bool operator== (const Win &obj) {
      return (the_real_win == obj.the_real_win); }
    bool operator!= (const Win &obj) {
      return (the_real_win != obj.the_real_win); }
    // C/C++ cast and assignment
    inline operator MPI_Win*() { return &the_real_win; }
    inline operator MPI_Win() const { return the_real_win; }
    Win& operator=(const MPI_Win& obj) {
      the_real_win = obj; return *this; }
    void Free( void )
    {
        MPIX_CALL( MPI_Win_free( (MPI_Win *) &the_real_win ));
    }
    static Win Create( void * v1, Aint v2, int v3, Info v4, Comm v5 )
    {
        Win *v6 = new Win;
        MPIX_CALL( MPI_Win_create( v1, v2, v3, (MPI_Info)(v4.the_real_info), (MPI_Comm)(v5.the_real_comm), &(v6->the_real_win) ));
        return *v6;
    }
    Group Get_group( void )
    {
        Group *v2 = new Group;
        MPIX_CALL( MPI_Win_get_group( (MPI_Win) the_real_win, &(v2->the_real_group) ));
        return *v2;
    }
    void Get( void * v1, int v2, Datatype v3, int v4, Aint v5, int v6, Datatype v7 )
    {
        MPIX_CALL( MPI_Get( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, (MPI_Datatype)(v7.the_real_datatype), (MPI_Win) the_real_win ));
    }
    void Fence( int v1 )
    {
        MPIX_CALL( MPI_Win_fence( v1, (MPI_Win) the_real_win ));
    }
    void Accumulate( void * v1, int v2, Datatype v3, int v4, Aint v5, int v6, Datatype v7, Op v8 )
    {
        MPIX_CALL( MPI_Accumulate( (void *)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, (MPI_Datatype)(v7.the_real_datatype), (MPI_Op)(v8.the_real_op), (MPI_Win) the_real_win ));
    }
    void Put( const void * v1, int v2, Datatype v3, int v4, Aint v5, int v6, Datatype v7 )
    {
        MPIX_CALL( MPI_Put( (void *)v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, (MPI_Datatype)(v7.the_real_datatype), (MPI_Win) the_real_win ));
    }
};

class Graphcomm : public Intracomm {

  public:
    // new/delete
    inline Graphcomm(MPI_Comm obj) { the_real_comm = obj; }
    inline Graphcomm(void) {the_real_comm = MPI_COMM_NULL;}

    virtual ~Graphcomm() {}
    // copy/assignment
    Graphcomm(const Graphcomm &obj) {
      the_real_comm = obj.the_real_comm; }
    Graphcomm& operator=(const Graphcomm &obj) {
      the_real_comm = obj.the_real_comm; return *this; }

    // C/C++ cast and assignment
    inline operator MPI_Comm*() { return &the_real_comm; }
    inline operator MPI_Comm() const { return the_real_comm; }
    Graphcomm& operator=(const MPI_Comm& obj) {
      the_real_comm = obj; return *this; }
    int Map( int v2, int * v3, int * v4 )
    {
        int v5;
        MPIX_CALL( MPI_Graph_map( (MPI_Comm) the_real_comm, v2, v3, v4, &v5 ));
        return v5;
    }
    void Get_topo( int v2, int v3, int * v4, int * v5 )
    {
        MPIX_CALL( MPI_Graph_get( (MPI_Comm) the_real_comm, v2, v3, v4, v5 ));
    }
    void Get_neighbors( int v2, int v3, int * v4 )
    {
        MPIX_CALL( MPI_Graph_neighbors( (MPI_Comm) the_real_comm, v2, v3, v4 ));
    }
    int Get_neighbors_count( int v2 )
    {
        int v3;
        MPIX_CALL( MPI_Graph_neighbors_count( (MPI_Comm) the_real_comm, v2, &v3 ));
        return v3;
    }
    void Get_dims( int * v2, int * v3 )
    {
        MPIX_CALL( MPI_Graphdims_get( (MPI_Comm) the_real_comm, v2, v3 ));
    }
};

class Cartcomm : public Intracomm {

  public:
    // new/delete
    inline Cartcomm(MPI_Comm obj) { the_real_comm = obj; }
    inline Cartcomm(void) {the_real_comm = MPI_COMM_NULL;}

    virtual ~Cartcomm() {}
    // copy/assignment
    Cartcomm(const Cartcomm &obj) {
      the_real_comm = obj.the_real_comm; }
    Cartcomm& operator=(const Cartcomm &obj) {
      the_real_comm = obj.the_real_comm; return *this; }

    // C/C++ cast and assignment
    inline operator MPI_Comm*() { return &the_real_comm; }
    inline operator MPI_Comm() const { return the_real_comm; }
    Cartcomm& operator=(const MPI_Comm& obj) {
      the_real_comm = obj; return *this; }
    int Get_cart_rank( int * v2 )
    {
        int v3;
        MPIX_CALL( MPI_Cart_rank( (MPI_Comm) the_real_comm, v2, &v3 ));
        return v3;
    }
    int Map( int v2, int * v3, bool v4[] )
    {
        int v5;
        int *l4 = new int[v2];
        { 
            int i4; 
            for (i4=0;i4<v2;i4++) {
                l4[i4] = v4[i4] == true ? 1 : 0;
            }
        }
        MPIX_CALL( MPI_Cart_map( (MPI_Comm) the_real_comm, v2, v3, l4, &v5 ));

            delete[] l4;
        return v5;
    }
    void Shift( int v2, int v3, int &v4, int &v5 )
    {
        MPIX_CALL( MPI_Cart_shift( (MPI_Comm) the_real_comm, v2, v3, &v4, &v5 ));
    }
    void Get_topo( int v2, int * v3, bool v4[], int * v5 )
    {
        int *l4 = new int[v2];
        MPIX_CALL( MPI_Cart_get( (MPI_Comm) the_real_comm, v2, v3, l4, v5 ));
        { 
            int i4; 
            for (i4=0;i4<v2;i4++) {
                v4[i4] = l4[i4];
            }
            delete[] l4;
        }
    }
    Comm Sub( bool v2[] )
    {
        Comm *v3 = new Comm;
        int *l2 = new int[10];
        { 
            int i2; 
            for (i2=0;i2<10;i2++) {
                l2[i2] = v2[i2] == true ? 1 : 0;
            }
        }
        MPIX_CALL( MPI_Cart_sub( (MPI_Comm) the_real_comm, l2, &(v3->the_real_comm) ));

            delete[] l2;
        return *v3;
    }
    void Get_coords( int v2, int v3, int * v4 )
    {
        MPIX_CALL( MPI_Cart_coords( (MPI_Comm) the_real_comm, v2, v3, v4 ));
    }
    int Get_dim( void )
    {
        int v2;
        MPIX_CALL( MPI_Cartdim_get( (MPI_Comm) the_real_comm, &v2 ));
        return v2;
    }
    Comm Dup( void )
    {
        Comm *v2 = new Comm;
        MPIX_CALL( MPI_Comm_dup( (MPI_Comm) the_real_comm, &(v2->the_real_comm) ));
        return *v2;
    }
};
extern Datatype CHAR;
extern Datatype UNSIGNED_CHAR;
extern Datatype BYTE;
extern Datatype SHORT;
extern Datatype UNSIGNED_SHORT;
extern Datatype INT;
extern Datatype UNSIGNED;
extern Datatype LONG;
extern Datatype UNSIGNED_LONG;
extern Datatype FLOAT;
extern Datatype DOUBLE;
extern Datatype LONG_DOUBLE;
extern Datatype LONG_LONG_INT;
extern Datatype LONG_LONG;
extern Datatype PACKED;
extern Datatype LB;
extern Datatype UB;
extern Datatype FLOAT_INT;
extern Datatype DOUBLE_INT;
extern Datatype LONG_INT;
extern Datatype SHORT_INT;
extern Datatype LONG_DOUBLE_INT;
extern Datatype TWOINT;
extern Datatype DATATYPE_NULL;

#ifdef HAVE_FORTRAN_BINDING
extern Datatype INTEGER;
extern Datatype REAL;
extern Datatype DOUBLE_PRECISION;
extern Datatype F_COMPLEX;
extern Datatype F_DOUBLE_COMPLEX;
extern Datatype LOGICAL;
extern Datatype CHARACTER;
extern Datatype TWOREAL;
extern Datatype TWODOUBLE_PRECISION;
extern Datatype TWOINTEGER;
#endif
extern const Op MAX;
extern const Op MIN;
extern const Op SUM;
extern const Op PROD;
extern const Op LAND;
extern const Op BAND;
extern const Op LOR;
extern const Op BOR;
extern const Op LXOR;
extern const Op BXOR;
extern const Op MINLOC;
extern const Op MAXLOC;
extern const Op REPLACE;
extern const Op OP_NULL;
extern Intracomm COMM_WORLD;
extern Intracomm COMM_SELF;
extern const Comm COMM_NULL;
extern const Group GROUP_EMPTY;
extern const Group GROUP_NULL;
extern const Request REQUEST_NULL;
extern const Errhandler ERRHANDLER_NULL;
extern const Errhandler ERRORS_RETURN;
extern const Errhandler ERRORS_ARE_FATAL;
extern const Errhandler ERRORS_THROW_EXCEPTIONS;
extern const int BSEND_OVERHEAD;
extern const int KEYVAL_INVALID;
extern const int CART;
extern const int GRAPH;
extern const int IDENT;
extern const int SIMILAR;
extern const int CONGRUENT;
extern const int UNEQUAL;
extern const int PROC_NULL;
extern const int ANY_TAG;
extern const int ANY_SOURCE;
extern const int ROOT;
extern const int TAG_UB;
extern const int IO;
extern const int HOST;
extern const int WTIME_IS_GLOBAL;
extern const int UNIVERSE;
extern const int LASTUSEDCODE;
extern const int APPNUM;
extern const int MAX_PROCESSOR_NAME;
extern const int MAX_ERROR_STRING;
extern const int MAX_NAME_STRING;
extern const int MAX_PORT_NAME;
extern const int MAX_OBJECT_NAME;
extern const int MAX_INFO_VAL;
extern const int MAX_INFO_KEY;
extern const int UNDEFINED;
extern const int SUCCESS;
extern const int ERR_BUFFER;
extern const int ERR_COUNT;
extern const int ERR_TYPE;
extern const int ERR_TAG;
extern const int ERR_COMM;
extern const int ERR_RANK;
extern const int ERR_REQUEST;
extern const int ERR_ROOT;
extern const int ERR_GROUP;
extern const int ERR_OP;
extern const int ERR_TOPOLOGY;
extern const int ERR_DIMS;
extern const int ERR_ARG;
extern const int ERR_UNKNOWN;
extern const int ERR_TRUNCATE;
extern const int ERR_OTHER;
extern const int ERR_INTERN;
extern const int ERR_PENDING;
extern const int ERR_IN_STATUS;
extern const int ERR_LASTCODE;
extern const int ERR_FILE;
extern const int ERR_ACCESS;
extern const int ERR_AMODE;
extern const int ERR_BAD_FILE;
extern const int ERR_FILE_EXISTS;
extern const int ERR_FILE_IN_USE;
extern const int ERR_NO_SPACE;
extern const int ERR_NO_SUCH_FILE;
extern const int ERR_IO;
extern const int ERR_READ_ONLY;
extern const int ERR_CONVERSION;
extern const int ERR_DUP_DATAREP;
extern const int ERR_UNSUPPORTED_DATAREP;
extern const int ERR_INFO;
extern const int ERR_INFO_KEY;
extern const int ERR_INFO_VALUE;
extern const int ERR_INFO_NOKEY;
extern const int ERR_NAME;
extern const int ERR_NO_MEM;
extern const int ERR_NOT_SAME;
extern const int ERR_PORT;
extern const int ERR_QUOTA;
extern const int ERR_SERVICE;
extern const int ERR_SPAWN;
extern const int ERR_UNSUPPORTED_OPERATION;
extern const int ERR_WIN;
extern const int ERR_BASE;
extern const int ERR_LOCKTYPE;
extern const int ERR_KEYVAL;
extern const int ERR_RMA_CONFLICT;
extern const int ERR_RMA_SYNC;
extern const int ERR_SIZE;
extern const int ERR_DISP;
extern const int ERR_ASSERT;
extern const void *BOTTOM;
extern void Init(void);
extern void Init(int &, char **& );
extern void Finalize(void);
extern Aint Get_address( void * );
extern double Wtime(void);
extern double Wtick(void);
} // namespace MPI
